//
// $Id$
//
// Narya library - tools for developing networked games
// Copyright (C) 2002-2012 Three Rings Design, Inc., All Rights Reserved
// http://code.google.com/p/narya/
//
// This library is free software; you can redistribute it and/or modify it
// under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation; either version 2.1 of the License, or
// (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

package com.threerings.crowd.data {

import com.threerings.io.ObjectInputStream;
import com.threerings.io.ObjectOutputStream;
import com.threerings.io.SimpleStreamableObject;

import com.threerings.util.Hashable;

/**
 * Contains information on the current place occupied by a body.
 */
public class Place extends SimpleStreamableObject
    implements Hashable
{
    /** The oid of this place's {@link PlaceObject}. */
    public var placeOid :int;

    /**
     * Creates a place with the supplied oid.
     */
    public function Place (placeOid :int = 0)
    {
        this.placeOid = placeOid;
    }

    // from Object
    public function hashCode () :int
    {
        return placeOid;
    }

    // from Object
    public function equals (other :Object) :Boolean
    {
        return (other is Place) && ((other as Place).placeOid == placeOid);
    }

    // from interface Streamable
    override public function readObject (ins :ObjectInputStream) :void
    {
        super.readObject(ins);
        placeOid = ins.readInt();
    }

    // from interface Streamable
    override public function writeObject (out :ObjectOutputStream) :void
    {
        super.writeObject(out);
        out.writeInt(placeOid);
    }
}
}
